
#include <Servo.h>
Servo myservo;

#define X_STEP_PIN         54
#define X_DIR_PIN          55
#define X_ENABLE_PIN       38

char data=0;//byte to receive and check data from computer
void setup() { 
  myservo.attach(11);           
  Serial.begin(9600);//Start the Serial port.  
  pinMode(X_STEP_PIN   , OUTPUT);
  pinMode(X_DIR_PIN     , OUTPUT);
  pinMode(X_ENABLE_PIN      , OUTPUT);
 
  backward(0);
  }
 void loop()
 {
  if(Serial.available())
  {//if there is data on the Serial buffer
    while(Serial.available()>0)
   {//continues reading the values on the buffer.
      data=Serial.read();
      Serial.print(data);
      if(data=='1'){
        braille();//if a one was received, makes a dot.
        forward(3200);//avances one time (four steps)
      }
      }
  }
}
void forward(int number){
digitalWrite(X_DIR_PIN    ,HIGH);
  for(int i=0;i<=number;i++)
  {
    digitalWrite(X_STEP_PIN    , HIGH);
    _delay_us(500);
    digitalWrite(X_STEP_PIN    , LOW);
    _delay_us(500);
  }
  }
 void backward(int number){
 digitalWrite(X_DIR_PIN    , LOW);
  for(int i=0;i<=number;i++)
  {
    digitalWrite(X_STEP_PIN    , HIGH);
    _delay_us(500);
    digitalWrite(X_STEP_PIN    , LOW);
    _delay_us(500);
  }
  }
 void braille(void){
  myservo.write(0);
  delay(100);
  myservo.write(50);
}

